<%@ Import Namespace="System"%>
<%@ Import Namespace="System.Net"%>
<%@ Import Namespace="System.Text"%>
<%@ Import Namespace="System.Web.Services.Protocols"%>
<%@ Import Namespace="System.Xml"%>
<%@ Import Namespace="System.Xml.Serialization"%>
<%@ Import Namespace="System.ComponentModel"%>
<%@ Import Namespace="Microsoft.Crm.Platform.Proxy"%>


<HTML>
	<HEAD>
		<title>c360 Solutions - Clone Entity ...</title>
		<link rel="stylesheet" type="text/css" href="/_common/styles/select.css">
		<link rel="stylesheet" type="text/css" href="/_nav/tabs.css">
		<link rel="stylesheet" type="text/css" href="/_nav/nav.css">
		<link rel="stylesheet" type="text/css" href="/_nav/menu.css">
		<link rel="stylesheet" type="text/css" href="/_common/styles/global.css">
		<link rel="stylesheet" type="text/css" href="/_forms/controls/form.css">
		<script language="javascript">
		function DisplayNewRecord(iType, sId) {
			try {
				// Refresh the main grid
				var objWindow = window.opener;
				while(objWindow.opener != undefined) {
					objWindow = objWindow.opener;
				}
				objWindow.crmGrid.location.reload();
			} catch (e) {  }
			
			try {
				// Display the newly created record
				window.opener.openObj(iType, sId);
			} catch (e) {  }
			
			try {
				// Close this window
				window.close();
			} catch (e) {  }
		}
		</script>
		
		<script language="C#" runat="server">
		
		CrmService _service;

		void Page_Init() {
			string strObjectId = System.Web.HttpContext.Current.Request.QueryString["oId"].ToString();
			string strObjectType = System.Web.HttpContext.Current.Request.QueryString["oType"].ToString();
			string returnGUID = "";
			string webServicesUrl = "";
			string serverName = "";

			// Buld the URL to the CRM web services:
			//	1) Read a key called 'CRMServer' from web.config
			//	2) The value of this key must start with either http:// or https://
			//	3) This value must contain the name of the CRM server (or host header)
			//	4) The IP port number can be added at the end of the value if necessary
			// Here is an example: <add key="CRMServer" value="http://crm:5555"/>
			if (ConfigurationSettings.AppSettings["CRMServer"] == null) {
				throw new ArgumentNullException("CRMServer", "The CRMServer key is missing from the web.config file or is empty.");
			}
			serverName = ConfigurationSettings.AppSettings["CRMServer"].ToString();
			if (!serverName.StartsWith("http://") && !serverName.StartsWith("https://")) {
				throw new ArgumentException("CRMServer", "The CRMServer key must start with http:// or https://");
			}
			if (!serverName.EndsWith("/")) {
				serverName += "/";
			}
			webServicesUrl = string.Concat(serverName, "/MSCRMServices/2006/CrmService.asmx" );


			// create the CrmService webservice
			_service = new CrmService( webServicesUrl );
			_service.Credentials = CredentialCache.DefaultCredentials;
			
			BusinessEntity returnEntity = RetrieveObject( Int16.Parse(strObjectType), strObjectId );
		
			if (returnEntity != null) {
				returnGUID = CloneObject(Int16.Parse(strObjectType), returnEntity );
			}

			if (returnGUID != null) {
				lblResult.Text += "<h4>Object sucessfully cloned.</h4><a href='javascript:DisplayNewRecord(" + strObjectType + @", """ + returnGUID + @""");'>Click here to close this window</br>and display the new object.</a></br></br></br>Another great CRM utility from</br><b>c360 Solutions - www.c360.com</b>";
			}
		}

		private BusinessEntity RetrieveObject( int iObjectType, string strObjectId ) {
			string entityName = "";
		
			switch(iObjectType) {         
				case 1:         
					entityName = "account";
					break;
			
				case 2:
					entityName = "contact";
					break;
				
				case 3:
					entityName = "opportunity";
					break;
					
				case 4:
					entityName = "lead";
					break;

				case 112:
					entityName = "incident";
					break;
					
				case 123:
					entityName = "competitor";
					break;
					
				case 1084:
					entityName = "quote";
					break;

				case 1088:
					entityName = "salesorder";
					break;

				case 1090:
					entityName = "invoice";
					break;
			}

			
			return  _service.Retrieve( entityName, new Guid(strObjectId), new AllColumns() );
		}


		private string CloneObject(int iObjectType, BusinessEntity selectedEntity ) {
			StringBuilder strFieldSet = new StringBuilder("");
			Guid ClonedEntityGuid = new Guid();

			
			switch(iObjectType) {         
				case 1:      
					account accountEntity = ( account ) selectedEntity;

					accountEntity.name = "Clone of " + accountEntity.name;
					accountEntity.accountid = null;
					accountEntity.address1_addressid = null;
					accountEntity.address2_addressid = null;
					accountEntity.aging30 = null;
					accountEntity.aging60 = null;
					accountEntity.aging90 = null;

					ClonedEntityGuid = _service.Create( accountEntity );

					break;
			
				case 2:
					contact contactEntity = ( contact ) selectedEntity; 
					contactEntity.firstname = "Clone of " + contactEntity.firstname;

					contactEntity.contactid = null;
					contactEntity.fullname = null;
					contactEntity.yomifullname = null;
					contactEntity.aging30 = null;
					contactEntity.aging60 = null;
					contactEntity.aging90 = null;
					contactEntity.address1_addressid = null;
					contactEntity.address2_addressid = null;

					ClonedEntityGuid = _service.Create( contactEntity );
					break;
				
				case 3:
					opportunity oppEntity = ( opportunity ) selectedEntity; 
					oppEntity.name = "Clone of " + oppEntity.name;
					oppEntity.opportunityid = null;
					ClonedEntityGuid = _service.Create( oppEntity );
					break;
					
				case 4:
					lead leadEntity = ( lead ) selectedEntity; 
					leadEntity.subject = "Clone of " + leadEntity.subject;

					leadEntity.leadid = null;
					leadEntity.yomifullname = null;
					leadEntity.fullname = null;
					leadEntity.address1_addressid = null;
					leadEntity.address2_addressid = null;

					ClonedEntityGuid = _service.Create( leadEntity );
					break;

				case 112:
					incident incidentEntity = ( incident ) selectedEntity; 
					incidentEntity.title = "Clone of " + incidentEntity.title;
					ClonedEntityGuid = _service.Create( incidentEntity );
					break;
					
				case 123:
					competitor competitorEntity = ( competitor ) selectedEntity; 
					competitorEntity.name = "Clone of " + competitorEntity.name;
					ClonedEntityGuid = _service.Create( competitorEntity );
					break;
					
					////					case 1084:
					////						quote cloneEntity = ( quote ) selectedEntity; 
					////						cloneEntity.name = "Clone of " + cloneEntity.name;
					////						ClonedEntityGuid = _service.Create( cloneEntity );
					////						break;

				case 1088:
					salesorder salesEntity = ( salesorder ) selectedEntity; 
					salesEntity.name = "Clone of " + salesEntity.name;
					ClonedEntityGuid = _service.Create( salesEntity );
					break;

				case 1090:
					invoice invoiceEntity = ( invoice ) selectedEntity; 
					invoiceEntity.name = "Clone of " + invoiceEntity.name;
					ClonedEntityGuid = _service.Create( invoiceEntity );
					break;
			}
				
			

			return ClonedEntityGuid.ToString();
		}

		
		
    
    
		/// <remarks/>
		[System.Diagnostics.DebuggerStepThroughAttribute()]
			[System.ComponentModel.DesignerCategoryAttribute("code")]
			[System.Web.Services.WebServiceBindingAttribute(Name="CrmServiceSoap", Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CrmReference))]
			public class CrmService : System.Web.Services.Protocols.SoapHttpClientProtocol {
        
			public CallerId CallerIdValue;
        
			/// <remarks/>
			public CrmService( string ServiceURL ) {
				this.Url = ServiceURL;
			}
        
			/// <remarks/>
			[System.Web.Services.Protocols.SoapHeaderAttribute("CallerIdValue")]
			[System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://schemas.microsoft.com/crm/2006/WebServices/Execute", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Bare)]
			[return: System.Xml.Serialization.XmlElementAttribute("Response", Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public Response Execute([System.Xml.Serialization.XmlElementAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")] Request Request) {
				object[] results = this.Invoke("Execute", new object[] {
																		   Request});
				return ((Response)(results[0]));
			}
	     
			/// <remarks/>
			[System.Web.Services.Protocols.SoapHeaderAttribute("CallerIdValue")]
			[System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://schemas.microsoft.com/crm/2006/WebServices/Create", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Bare)]
			[return: System.Xml.Serialization.XmlElementAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public System.Guid Create([System.Xml.Serialization.XmlElementAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")] BusinessEntity entity) {
				object[] results = this.Invoke("Create", new object[] {
																		  entity});
				return ((System.Guid)(results[0]));
			}
		       
			/// <remarks/>
			[System.Web.Services.Protocols.SoapHeaderAttribute("CallerIdValue")]
			[System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://schemas.microsoft.com/crm/2006/WebServices/Retrieve", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Bare)]
			[return: System.Xml.Serialization.XmlElementAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public BusinessEntity Retrieve([System.Xml.Serialization.XmlElementAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")] string entityName, [System.Xml.Serialization.XmlElementAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")] System.Guid id, [System.Xml.Serialization.XmlElementAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")] ColumnSetBase columnSet) {
				object[] results = this.Invoke("Retrieve", new object[] {
																			entityName,
																			id,
																			columnSet});
				return ((BusinessEntity)(results[0]));
			}
		
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/CoreTypes")]
			[System.Xml.Serialization.XmlRootAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices", IsNullable=true)]
			public class CallerId : System.Web.Services.Protocols.SoapHeader {
        
			/// <remarks/>
			public System.Guid CallerGuid;
		}
		
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmDateTime {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string date;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string time;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public string Value;
		}
    
		
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			//    [System.Xml.Serialization.XmlIncludeAttribute(typeof(LoseOpportunityResponse))]
			public abstract class Response {
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(contact))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(account))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(lead))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(invoice))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(incident))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(opportunity))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(competitor))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(salesorder))]
			public abstract class BusinessEntity {
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class invoicedetail : BusinessEntity {
        
			/// <remarks/>
			public CrmDateTime actualdeliveryon;
        
			/// <remarks/>
			public CrmMoney baseamount;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmMoney extendedamount;
        
			/// <remarks/>
			public Key invoicedetailid;
        
			/// <remarks/>
			public Lookup invoiceid;
        
			/// <remarks/>
			public CrmBoolean invoiceispricelocked;
        
			/// <remarks/>
			public Picklist invoicestatecode;
        
			/// <remarks/>
			public CrmBoolean iscopied;
        
			/// <remarks/>
			public CrmBoolean ispriceoverridden;
        
			/// <remarks/>
			public CrmBoolean isproductoverridden;
        
			/// <remarks/>
			public CrmNumber lineitemnumber;
        
			/// <remarks/>
			public CrmMoney manualdiscountamount;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public UniqueIdentifier owningbusinessunit;
        
			/// <remarks/>
			public UniqueIdentifier owninguser;
        
			/// <remarks/>
			public CrmMoney priceperunit;
        
			/// <remarks/>
			public Picklist pricingerrorcode;
        
			/// <remarks/>
			public string productdescription;
        
			/// <remarks/>
			public Lookup productid;
        
			/// <remarks/>
			public CrmDecimal quantity;
        
			/// <remarks/>
			public CrmDecimal quantitybackordered;
        
			/// <remarks/>
			public CrmDecimal quantitycancelled;
        
			/// <remarks/>
			public CrmDecimal quantityshipped;
        
			/// <remarks/>
			public Lookup salesrepid;
        
			/// <remarks/>
			public string shippingtrackingnumber;
        
			/// <remarks/>
			public string shipto_city;
        
			/// <remarks/>
			public string shipto_country;
        
			/// <remarks/>
			public string shipto_fax;
        
			/// <remarks/>
			public Picklist shipto_freighttermscode;
        
			/// <remarks/>
			public string shipto_line1;
        
			/// <remarks/>
			public string shipto_line2;
        
			/// <remarks/>
			public string shipto_line3;
        
			/// <remarks/>
			public string shipto_name;
        
			/// <remarks/>
			public string shipto_postalcode;
        
			/// <remarks/>
			public string shipto_stateorprovince;
        
			/// <remarks/>
			public string shipto_telephone;
        
			/// <remarks/>
			public CrmMoney tax;
        
			/// <remarks/>
			public Lookup uomid;
        
			/// <remarks/>
			public CrmMoney volumediscountamount;
        
			/// <remarks/>
			public CrmBoolean willcall;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmMoney {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public System.Decimal Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class Lookup : CrmReference {
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(Owner))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(Lookup))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(Customer))]
			public class CrmReference {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string name;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string type;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public int dsc;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool dscSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public System.Guid Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class Owner : CrmReference {
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class Customer : CrmReference {
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class Key {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public System.Guid Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmBoolean {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string name;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public bool Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class Picklist {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string name;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public int Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmNumber {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public int Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class UniqueIdentifier {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public System.Guid Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmDecimal {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public System.Decimal Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class contact : BusinessEntity {
        
			/// <remarks/>
			public Picklist accountrolecode;
        
			/// <remarks/>
			public Key address1_addressid;
        
			/// <remarks/>
			public Picklist address1_addresstypecode;
        
			/// <remarks/>
			public string address1_city;
        
			/// <remarks/>
			public string address1_country;
        
			/// <remarks/>
			public string address1_county;
        
			/// <remarks/>
			public string address1_fax;
        
			/// <remarks/>
			public Picklist address1_freighttermscode;
        
			/// <remarks/>
			public CrmFloat address1_latitude;
        
			/// <remarks/>
			public string address1_line1;
        
			/// <remarks/>
			public string address1_line2;
        
			/// <remarks/>
			public string address1_line3;
        
			/// <remarks/>
			public CrmFloat address1_longitude;
        
			/// <remarks/>
			public string address1_name;
        
			/// <remarks/>
			public string address1_postalcode;
        
			/// <remarks/>
			public string address1_postofficebox;
        
			/// <remarks/>
			public string address1_primarycontactname;
        
			/// <remarks/>
			public Picklist address1_shippingmethodcode;
        
			/// <remarks/>
			public string address1_stateorprovince;
        
			/// <remarks/>
			public string address1_telephone1;
        
			/// <remarks/>
			public string address1_telephone2;
        
			/// <remarks/>
			public string address1_telephone3;
        
			/// <remarks/>
			public string address1_upszone;
        
			/// <remarks/>
			public CrmNumber address1_utcoffset;
        
			/// <remarks/>
			public Key address2_addressid;
        
			/// <remarks/>
			public Picklist address2_addresstypecode;
        
			/// <remarks/>
			public string address2_city;
        
			/// <remarks/>
			public string address2_country;
        
			/// <remarks/>
			public string address2_county;
        
			/// <remarks/>
			public string address2_fax;
        
			/// <remarks/>
			public Picklist address2_freighttermscode;
        
			/// <remarks/>
			public CrmFloat address2_latitude;
        
			/// <remarks/>
			public string address2_line1;
        
			/// <remarks/>
			public string address2_line2;
        
			/// <remarks/>
			public string address2_line3;
        
			/// <remarks/>
			public CrmFloat address2_longitude;
        
			/// <remarks/>
			public string address2_name;
        
			/// <remarks/>
			public string address2_postalcode;
        
			/// <remarks/>
			public string address2_postofficebox;
        
			/// <remarks/>
			public string address2_primarycontactname;
        
			/// <remarks/>
			public Picklist address2_shippingmethodcode;
        
			/// <remarks/>
			public string address2_stateorprovince;
        
			/// <remarks/>
			public string address2_telephone1;
        
			/// <remarks/>
			public string address2_telephone2;
        
			/// <remarks/>
			public string address2_telephone3;
        
			/// <remarks/>
			public string address2_upszone;
        
			/// <remarks/>
			public CrmNumber address2_utcoffset;
        
			/// <remarks/>
			public CrmMoney aging30;
        
			/// <remarks/>
			public CrmMoney aging60;
        
			/// <remarks/>
			public CrmMoney aging90;
        
			/// <remarks/>
			public CrmDateTime anniversary;
        
			/// <remarks/>
			public CrmMoney annualincome;
        
			/// <remarks/>
			public string assistantname;
        
			/// <remarks/>
			public string assistantphone;
        
			/// <remarks/>
			public CrmDateTime birthdate;
        
			/// <remarks/>
			public string childrensnames;
        
			/// <remarks/>
			public Key contactid;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public CrmMoney creditlimit;
        
			/// <remarks/>
			public CrmBoolean creditonhold;
        
			/// <remarks/>
			public Picklist customersizecode;
        
			/// <remarks/>
			public Picklist customertypecode;
        
			/// <remarks/>
			public Lookup defaultpricelevelid;
        
			/// <remarks/>
			public string department;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmBoolean donotbulkemail;
        
			/// <remarks/>
			public CrmBoolean donotbulkpostalmail;
        
			/// <remarks/>
			public CrmBoolean donotemail;
        
			/// <remarks/>
			public CrmBoolean donotfax;
        
			/// <remarks/>
			public CrmBoolean donotphone;
        
			/// <remarks/>
			public CrmBoolean donotpostalmail;
        
			/// <remarks/>
			public CrmBoolean donotsendmm;
        
			/// <remarks/>
			public Picklist educationcode;
        
			/// <remarks/>
			public string emailaddress1;
        
			/// <remarks/>
			public string emailaddress2;
        
			/// <remarks/>
			public string emailaddress3;
        
			/// <remarks/>
			public string employeeid;
        
			/// <remarks/>
			public string externaluseridentifier;
        
			/// <remarks/>
			public Picklist familystatuscode;
        
			/// <remarks/>
			public string fax;
        
			/// <remarks/>
			public string firstname;
        
			/// <remarks/>
			public string ftpsiteurl;
        
			/// <remarks/>
			public string fullname;
        
			/// <remarks/>
			public Picklist gendercode;
        
			/// <remarks/>
			public string governmentid;
        
			/// <remarks/>
			public Picklist haschildrencode;
        
			/// <remarks/>
			public CrmBoolean isbackofficecustomer;
        
			/// <remarks/>
			public string jobtitle;
        
			/// <remarks/>
			public string lastname;
        
			/// <remarks/>
			public CrmDateTime lastusedincampaign;
        
			/// <remarks/>
			public Picklist leadsourcecode;
        
			/// <remarks/>
			public string managername;
        
			/// <remarks/>
			public string managerphone;
        
			/// <remarks/>
			public Lookup masterid;
        
			/// <remarks/>
			public CrmBoolean merged;
        
			/// <remarks/>
			public string middlename;
        
			/// <remarks/>
			public string mobilephone;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public string nickname;
        
			/// <remarks/>
			public CrmNumber numberofchildren;
        
			/// <remarks/>
			public Lookup originatingleadid;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public string pager;
        
			/// <remarks/>
			public Customer parentcustomerid;
        
			/// <remarks/>
			public CrmBoolean participatesinworkflow;
        
			/// <remarks/>
			public Picklist paymenttermscode;
        
			/// <remarks/>
			public Picklist preferredappointmentdaycode;
        
			/// <remarks/>
			public Picklist preferredappointmenttimecode;
        
			/// <remarks/>
			public Picklist preferredcontactmethodcode;
        
			/// <remarks/>
			public Lookup preferredequipmentid;
        
			/// <remarks/>
			public Lookup preferredserviceid;
        
			/// <remarks/>
			public Lookup preferredsystemuserid;
        
			/// <remarks/>
			public string salutation;
        
			/// <remarks/>
			public Picklist shippingmethodcode;
        
			/// <remarks/>
			public string spousesname;
        
			/// <remarks/>
			public ContactStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public UniqueIdentifier subscriptionid;
        
			/// <remarks/>
			public string suffix;
        
			/// <remarks/>
			public string telephone1;
        
			/// <remarks/>
			public string telephone2;
        
			/// <remarks/>
			public string telephone3;
        
			/// <remarks/>
			public Picklist territorycode;
        
			/// <remarks/>
			public string websiteurl;
        
			/// <remarks/>
			public string yomifirstname;
        
			/// <remarks/>
			public string yomifullname;
        
			/// <remarks/>
			public string yomilastname;
        
			/// <remarks/>
			public string yomimiddlename;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmFloat {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public System.Single Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class ContactStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public ContactState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum ContactState {
        
			/// <remarks/>
			Active,
        
			/// <remarks/>
			Inactive,
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class Status {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public bool IsNull;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlIgnoreAttribute()]
			public bool IsNullSpecified;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string name;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public int Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class opportunityproduct : BusinessEntity {
        
			/// <remarks/>
			public CrmMoney baseamount;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmMoney extendedamount;
        
			/// <remarks/>
			public CrmBoolean ispriceoverridden;
        
			/// <remarks/>
			public CrmBoolean isproductoverridden;
        
			/// <remarks/>
			public CrmMoney manualdiscountamount;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public Lookup opportunityid;
        
			/// <remarks/>
			public Key opportunityproductid;
        
			/// <remarks/>
			public Picklist opportunitystatecode;
        
			/// <remarks/>
			public UniqueIdentifier owningbusinessunit;
        
			/// <remarks/>
			public UniqueIdentifier owninguser;
        
			/// <remarks/>
			public CrmMoney priceperunit;
        
			/// <remarks/>
			public Picklist pricingerrorcode;
        
			/// <remarks/>
			public string productdescription;
        
			/// <remarks/>
			public Lookup productid;
        
			/// <remarks/>
			public CrmDecimal quantity;
        
			/// <remarks/>
			public CrmMoney tax;
        
			/// <remarks/>
			public Lookup uomid;
        
			/// <remarks/>
			public CrmMoney volumediscountamount;
		}

		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class EntityNameReference {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public string Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class account : BusinessEntity {
        
			/// <remarks/>
			public Picklist accountcategorycode;
        
			/// <remarks/>
			public Picklist accountclassificationcode;
        
			/// <remarks/>
			public Key accountid;
        
			/// <remarks/>
			public string accountnumber;
        
			/// <remarks/>
			public Picklist accountratingcode;
        
			/// <remarks/>
			public Key address1_addressid;
        
			/// <remarks/>
			public Picklist address1_addresstypecode;
        
			/// <remarks/>
			public string address1_city;
        
			/// <remarks/>
			public string address1_country;
        
			/// <remarks/>
			public string address1_county;
        
			/// <remarks/>
			public string address1_fax;
        
			/// <remarks/>
			public Picklist address1_freighttermscode;
        
			/// <remarks/>
			public CrmFloat address1_latitude;
        
			/// <remarks/>
			public string address1_line1;
        
			/// <remarks/>
			public string address1_line2;
        
			/// <remarks/>
			public string address1_line3;
        
			/// <remarks/>
			public CrmFloat address1_longitude;
        
			/// <remarks/>
			public string address1_name;
        
			/// <remarks/>
			public string address1_postalcode;
        
			/// <remarks/>
			public string address1_postofficebox;
        
			/// <remarks/>
			public string address1_primarycontactname;
        
			/// <remarks/>
			public Picklist address1_shippingmethodcode;
        
			/// <remarks/>
			public string address1_stateorprovince;
        
			/// <remarks/>
			public string address1_telephone1;
        
			/// <remarks/>
			public string address1_telephone2;
        
			/// <remarks/>
			public string address1_telephone3;
        
			/// <remarks/>
			public string address1_upszone;
        
			/// <remarks/>
			public CrmNumber address1_utcoffset;
        
			/// <remarks/>
			public Key address2_addressid;
        
			/// <remarks/>
			public Picklist address2_addresstypecode;
        
			/// <remarks/>
			public string address2_city;
        
			/// <remarks/>
			public string address2_country;
        
			/// <remarks/>
			public string address2_county;
        
			/// <remarks/>
			public string address2_fax;
        
			/// <remarks/>
			public Picklist address2_freighttermscode;
        
			/// <remarks/>
			public CrmFloat address2_latitude;
        
			/// <remarks/>
			public string address2_line1;
        
			/// <remarks/>
			public string address2_line2;
        
			/// <remarks/>
			public string address2_line3;
        
			/// <remarks/>
			public CrmFloat address2_longitude;
        
			/// <remarks/>
			public string address2_name;
        
			/// <remarks/>
			public string address2_postalcode;
        
			/// <remarks/>
			public string address2_postofficebox;
        
			/// <remarks/>
			public string address2_primarycontactname;
        
			/// <remarks/>
			public Picklist address2_shippingmethodcode;
        
			/// <remarks/>
			public string address2_stateorprovince;
        
			/// <remarks/>
			public string address2_telephone1;
        
			/// <remarks/>
			public string address2_telephone2;
        
			/// <remarks/>
			public string address2_telephone3;
        
			/// <remarks/>
			public string address2_upszone;
        
			/// <remarks/>
			public CrmNumber address2_utcoffset;
        
			/// <remarks/>
			public CrmMoney aging30;
        
			/// <remarks/>
			public CrmMoney aging60;
        
			/// <remarks/>
			public CrmMoney aging90;
        
			/// <remarks/>
			public Picklist businesstypecode;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public CrmMoney creditlimit;
        
			/// <remarks/>
			public CrmBoolean creditonhold;
        
			/// <remarks/>
			public Picklist customersizecode;
        
			/// <remarks/>
			public Picklist customertypecode;
        
			/// <remarks/>
			public Lookup defaultpricelevelid;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmBoolean donotbulkemail;
        
			/// <remarks/>
			public CrmBoolean donotbulkpostalmail;
        
			/// <remarks/>
			public CrmBoolean donotemail;
        
			/// <remarks/>
			public CrmBoolean donotfax;
        
			/// <remarks/>
			public CrmBoolean donotphone;
        
			/// <remarks/>
			public CrmBoolean donotpostalmail;
        
			/// <remarks/>
			public CrmBoolean donotsendmm;
        
			/// <remarks/>
			public string emailaddress1;
        
			/// <remarks/>
			public string emailaddress2;
        
			/// <remarks/>
			public string emailaddress3;
        
			/// <remarks/>
			public string fax;
        
			/// <remarks/>
			public string ftpsiteurl;
        
			/// <remarks/>
			public Picklist industrycode;
        
			/// <remarks/>
			public CrmDateTime lastusedincampaign;
        
			/// <remarks/>
			public CrmMoney marketcap;
        
			/// <remarks/>
			public Lookup masterid;
        
			/// <remarks/>
			public CrmBoolean merged;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public string name;
        
			/// <remarks/>
			public CrmNumber numberofemployees;
        
			/// <remarks/>
			public Lookup originatingleadid;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Picklist ownershipcode;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public Lookup parentaccountid;
        
			/// <remarks/>
			public CrmBoolean participatesinworkflow;
        
			/// <remarks/>
			public Picklist paymenttermscode;
        
			/// <remarks/>
			public Picklist preferredappointmentdaycode;
        
			/// <remarks/>
			public Picklist preferredappointmenttimecode;
        
			/// <remarks/>
			public Picklist preferredcontactmethodcode;
        
			/// <remarks/>
			public Lookup preferredequipmentid;
        
			/// <remarks/>
			public Lookup preferredserviceid;
        
			/// <remarks/>
			public Lookup preferredsystemuserid;
        
			/// <remarks/>
			public Lookup primarycontactid;
        
			/// <remarks/>
			public CrmMoney revenue;
        
			/// <remarks/>
			public CrmNumber sharesoutstanding;
        
			/// <remarks/>
			public Picklist shippingmethodcode;
        
			/// <remarks/>
			public string sic;
        
			/// <remarks/>
			public AccountStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public string stockexchange;
        
			/// <remarks/>
			public string telephone1;
        
			/// <remarks/>
			public string telephone2;
        
			/// <remarks/>
			public string telephone3;
        
			/// <remarks/>
			public Picklist territorycode;
        
			/// <remarks/>
			public Lookup territoryid;
        
			/// <remarks/>
			public string tickersymbol;
        
			/// <remarks/>
			public string websiteurl;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class AccountStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public AccountState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum AccountState {
        
			/// <remarks/>
			Active,
        
			/// <remarks/>
			Inactive,
		}
       
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class lead : BusinessEntity {
        
			/// <remarks/>
			public Key address1_addressid;
        
			/// <remarks/>
			public Picklist address1_addresstypecode;
        
			/// <remarks/>
			public string address1_city;
        
			/// <remarks/>
			public string address1_country;
        
			/// <remarks/>
			public string address1_county;
        
			/// <remarks/>
			public string address1_fax;
        
			/// <remarks/>
			public CrmFloat address1_latitude;
        
			/// <remarks/>
			public string address1_line1;
        
			/// <remarks/>
			public string address1_line2;
        
			/// <remarks/>
			public string address1_line3;
        
			/// <remarks/>
			public CrmFloat address1_longitude;
        
			/// <remarks/>
			public string address1_name;
        
			/// <remarks/>
			public string address1_postalcode;
        
			/// <remarks/>
			public string address1_postofficebox;
        
			/// <remarks/>
			public Picklist address1_shippingmethodcode;
        
			/// <remarks/>
			public string address1_stateorprovince;
        
			/// <remarks/>
			public string address1_telephone1;
        
			/// <remarks/>
			public string address1_telephone2;
        
			/// <remarks/>
			public string address1_telephone3;
        
			/// <remarks/>
			public string address1_upszone;
        
			/// <remarks/>
			public CrmNumber address1_utcoffset;
        
			/// <remarks/>
			public Key address2_addressid;
        
			/// <remarks/>
			public Picklist address2_addresstypecode;
        
			/// <remarks/>
			public string address2_city;
        
			/// <remarks/>
			public string address2_country;
        
			/// <remarks/>
			public string address2_county;
        
			/// <remarks/>
			public string address2_fax;
        
			/// <remarks/>
			public CrmFloat address2_latitude;
        
			/// <remarks/>
			public string address2_line1;
        
			/// <remarks/>
			public string address2_line2;
        
			/// <remarks/>
			public string address2_line3;
        
			/// <remarks/>
			public CrmFloat address2_longitude;
        
			/// <remarks/>
			public string address2_name;
        
			/// <remarks/>
			public string address2_postalcode;
        
			/// <remarks/>
			public string address2_postofficebox;
        
			/// <remarks/>
			public Picklist address2_shippingmethodcode;
        
			/// <remarks/>
			public string address2_stateorprovince;
        
			/// <remarks/>
			public string address2_telephone1;
        
			/// <remarks/>
			public string address2_telephone2;
        
			/// <remarks/>
			public string address2_telephone3;
        
			/// <remarks/>
			public string address2_upszone;
        
			/// <remarks/>
			public CrmNumber address2_utcoffset;
        
			/// <remarks/>
			public Lookup campaignid;
        
			/// <remarks/>
			public string companyname;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public Customer customerid;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmBoolean donotbulkemail;
        
			/// <remarks/>
			public CrmBoolean donotemail;
        
			/// <remarks/>
			public CrmBoolean donotfax;
        
			/// <remarks/>
			public CrmBoolean donotphone;
        
			/// <remarks/>
			public CrmBoolean donotpostalmail;
        
			/// <remarks/>
			public CrmBoolean donotsendmm;
        
			/// <remarks/>
			public string emailaddress1;
        
			/// <remarks/>
			public string emailaddress2;
        
			/// <remarks/>
			public string emailaddress3;
        
			/// <remarks/>
			public CrmDateTime estimatedclosedate;
        
			/// <remarks/>
			public CrmFloat estimatedvalue;
        
			/// <remarks/>
			public string fax;
        
			/// <remarks/>
			public string firstname;
        
			/// <remarks/>
			public string fullname;
        
			/// <remarks/>
			public Picklist industrycode;
        
			/// <remarks/>
			public string jobtitle;
        
			/// <remarks/>
			public string lastname;
        
			/// <remarks/>
			public CrmDateTime lastusedincampaign;
        
			/// <remarks/>
			public Key leadid;
        
			/// <remarks/>
			public Picklist leadqualitycode;
        
			/// <remarks/>
			public Picklist leadsourcecode;
        
			/// <remarks/>
			public Lookup masterid;
        
			/// <remarks/>
			public CrmBoolean merged;
        
			/// <remarks/>
			public string middlename;
        
			/// <remarks/>
			public string mobilephone;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public CrmBoolean new_inmarketingloop;
        
			/// <remarks/>
			public Picklist new_interestlevel;
        
			/// <remarks/>
			public CrmNumber new_marketingstage;
        
			/// <remarks/>
			public CrmNumber numberofemployees;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public string pager;
        
			/// <remarks/>
			public CrmBoolean participatesinworkflow;
        
			/// <remarks/>
			public Picklist preferredcontactmethodcode;
        
			/// <remarks/>
			public Picklist prioritycode;
        
			/// <remarks/>
			public CrmMoney revenue;
        
			/// <remarks/>
			public Picklist salesstagecode;
        
			/// <remarks/>
			public string salutation;
        
			/// <remarks/>
			public string sic;
        
			/// <remarks/>
			public LeadStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public string subject;
        
			/// <remarks/>
			public string telephone1;
        
			/// <remarks/>
			public string telephone2;
        
			/// <remarks/>
			public string telephone3;
        
			/// <remarks/>
			public string websiteurl;
        
			/// <remarks/>
			public string yomifirstname;
        
			/// <remarks/>
			public string yomifullname;
        
			/// <remarks/>
			public string yomilastname;
        
			/// <remarks/>
			public string yomimiddlename;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class LeadStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public LeadState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum LeadState {
        
			/// <remarks/>
			Open,
        
			/// <remarks/>
			Qualified,
        
			/// <remarks/>
			Disqualified,
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(StringProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CrmNumberProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(LookupProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(OwnerProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CustomerProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(PicklistProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(StateProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(StatusProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(KeyProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CrmFloatProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CrmBooleanProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(EntityNameReferenceProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(UniqueIdentifierProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CrmDecimalProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CrmDateTimeProperty))]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(CrmMoneyProperty))]
			public abstract class Property {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string Name;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class StringProperty : Property {
        
			/// <remarks/>
			public string Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmNumberProperty : Property {
        
			/// <remarks/>
			public CrmNumber Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class LookupProperty : Property {
        
			/// <remarks/>
			public Lookup Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class OwnerProperty : Property {
        
			/// <remarks/>
			public Owner Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CustomerProperty : Property {
        
			/// <remarks/>
			public Customer Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class PicklistProperty : Property {
        
			/// <remarks/>
			public Picklist Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class StateProperty : Property {
        
			/// <remarks/>
			public string Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class StatusProperty : Property {
        
			/// <remarks/>
			public Status Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class KeyProperty : Property {
        
			/// <remarks/>
			public Key Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmFloatProperty : Property {
        
			/// <remarks/>
			public CrmFloat Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmBooleanProperty : Property {
        
			/// <remarks/>
			public CrmBoolean Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class EntityNameReferenceProperty : Property {
        
			/// <remarks/>
			public EntityNameReference Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class UniqueIdentifierProperty : Property {
        
			/// <remarks/>
			public UniqueIdentifier Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmDecimalProperty : Property {
        
			/// <remarks/>
			public CrmDecimal Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmDateTimeProperty : Property {
        
			/// <remarks/>
			public CrmDateTime Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class CrmMoneyProperty : Property {
        
			/// <remarks/>
			public CrmMoney Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class invoice : BusinessEntity {
        
			/// <remarks/>
			public string billto_city;
        
			/// <remarks/>
			public string billto_country;
        
			/// <remarks/>
			public string billto_fax;
        
			/// <remarks/>
			public string billto_line1;
        
			/// <remarks/>
			public string billto_line2;
        
			/// <remarks/>
			public string billto_line3;
        
			/// <remarks/>
			public string billto_name;
        
			/// <remarks/>
			public string billto_postalcode;
        
			/// <remarks/>
			public string billto_stateorprovince;
        
			/// <remarks/>
			public string billto_telephone;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public Customer customerid;
        
			/// <remarks/>
			public CrmDateTime datedelivered;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmMoney discountamount;
        
			/// <remarks/>
			public CrmDecimal discountpercentage;
        
			/// <remarks/>
			public CrmDateTime duedate;
        
			/// <remarks/>
			public CrmMoney freightamount;
        
			/// <remarks/>
			public Key invoiceid;
        
			/// <remarks/>
			public string invoicenumber;
        
			/// <remarks/>
			public CrmBoolean ispricelocked;
        
			/// <remarks/>
			public CrmDateTime lastbackofficesubmit;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public string name;
        
			/// <remarks/>
			public Lookup opportunityid;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public Picklist paymenttermscode;
        
			/// <remarks/>
			public Lookup pricelevelid;
        
			/// <remarks/>
			public Picklist pricingerrorcode;
        
			/// <remarks/>
			public Picklist prioritycode;
        
			/// <remarks/>
			public Lookup salesorderid;
        
			/// <remarks/>
			public Picklist shippingmethodcode;
        
			/// <remarks/>
			public string shipto_city;
        
			/// <remarks/>
			public string shipto_country;
        
			/// <remarks/>
			public string shipto_fax;
        
			/// <remarks/>
			public Picklist shipto_freighttermscode;
        
			/// <remarks/>
			public string shipto_line1;
        
			/// <remarks/>
			public string shipto_line2;
        
			/// <remarks/>
			public string shipto_line3;
        
			/// <remarks/>
			public string shipto_name;
        
			/// <remarks/>
			public string shipto_postalcode;
        
			/// <remarks/>
			public string shipto_stateorprovince;
        
			/// <remarks/>
			public string shipto_telephone;
        
			/// <remarks/>
			public InvoiceStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public CrmMoney totalamount;
        
			/// <remarks/>
			public CrmMoney totalamountlessfreight;
        
			/// <remarks/>
			public CrmMoney totaldiscountamount;
        
			/// <remarks/>
			public CrmMoney totallineitemamount;
        
			/// <remarks/>
			public CrmMoney totallineitemdiscountamount;
        
			/// <remarks/>
			public CrmMoney totaltax;
        
			/// <remarks/>
			public CrmBoolean willcall;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class InvoiceStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public InvoiceState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum InvoiceState {
        
			/// <remarks/>
			Active,
        
			/// <remarks/>
			Closed,
        
			/// <remarks/>
			Paid,
        
			/// <remarks/>
			Canceled,
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class opportunityclose : BusinessEntity {
        
			/// <remarks/>
			public Key activityid;
        
			/// <remarks/>
			public CrmNumber actualdurationminutes;
        
			/// <remarks/>
			public CrmDateTime actualend;
        
			/// <remarks/>
			public CrmMoney actualrevenue;
        
			/// <remarks/>
			public CrmDateTime actualstart;
        
			/// <remarks/>
			public string category;
        
			/// <remarks/>
			public Lookup competitorid;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmBoolean isbilled;
        
			/// <remarks/>
			public CrmBoolean isworkflowcreated;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public Lookup opportunityid;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public CrmNumber scheduleddurationminutes;
        
			/// <remarks/>
			public CrmDateTime scheduledend;
        
			/// <remarks/>
			public CrmDateTime scheduledstart;
        
			/// <remarks/>
			public Lookup serviceid;
        
			/// <remarks/>
			public OpportunityCloseStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public string subcategory;
        
			/// <remarks/>
			public string subject;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class OpportunityCloseStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public OpportunityCloseState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum OpportunityCloseState {
        
			/// <remarks/>
			Open,
        
			/// <remarks/>
			Completed,
        
			/// <remarks/>
			Canceled,
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class incident : BusinessEntity {
        
			/// <remarks/>
			public CrmNumber actualserviceunits;
        
			/// <remarks/>
			public CrmNumber billedserviceunits;
        
			/// <remarks/>
			public Picklist caseorigincode;
        
			/// <remarks/>
			public Picklist casetypecode;
        
			/// <remarks/>
			public Lookup contractdetailid;
        
			/// <remarks/>
			public Lookup contractid;
        
			/// <remarks/>
			public Picklist contractservicelevelcode;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public Customer customerid;
        
			/// <remarks/>
			public Picklist customersatisfactioncode;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmDateTime followupby;
        
			/// <remarks/>
			public Key incidentid;
        
			/// <remarks/>
			public Picklist incidentstagecode;
        
			/// <remarks/>
			public CrmBoolean isdecrementing;
        
			/// <remarks/>
			public Lookup kbarticleid;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public Picklist prioritycode;
        
			/// <remarks/>
			public Lookup productid;
        
			/// <remarks/>
			public string productserialnumber;
        
			/// <remarks/>
			public Lookup responsiblecontactid;
        
			/// <remarks/>
			public Picklist severitycode;
        
			/// <remarks/>
			public IncidentStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public Lookup subjectid;
        
			/// <remarks/>
			public string ticketnumber;
        
			/// <remarks/>
			public string title;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class IncidentStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public IncidentState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum IncidentState {
        
			/// <remarks/>
			Active,
        
			/// <remarks/>
			Resolved,
        
			/// <remarks/>
			Canceled,
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class opportunity : BusinessEntity {
        
			/// <remarks/>
			public CrmDateTime actualclosedate;
        
			/// <remarks/>
			public CrmMoney actualvalue;
        
			/// <remarks/>
			public Lookup campaignid;
        
			/// <remarks/>
			public CrmNumber closeprobability;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public Customer customerid;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmDateTime estimatedclosedate;
        
			/// <remarks/>
			public CrmMoney estimatedvalue;
        
			/// <remarks/>
			public CrmBoolean isrevenuesystemcalculated;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public string name;
        
			/// <remarks/>
			public Key opportunityid;
        
			/// <remarks/>
			public Picklist opportunityratingcode;
        
			/// <remarks/>
			public Lookup originatingleadid;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public CrmBoolean participatesinworkflow;
        
			/// <remarks/>
			public Lookup pricelevelid;
        
			/// <remarks/>
			public Picklist pricingerrorcode;
        
			/// <remarks/>
			public Picklist prioritycode;
        
			/// <remarks/>
			public Picklist salesstagecode;
        
			/// <remarks/>
			public OpportunityStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public UniqueIdentifier stepid;
        
			/// <remarks/>
			public string stepname;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class OpportunityStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public OpportunityState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum OpportunityState {
        
			/// <remarks/>
			Open,
        
			/// <remarks/>
			Won,
        
			/// <remarks/>
			Lost,
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class competitor : BusinessEntity {
        
			/// <remarks/>
			public Key address1_addressid;
        
			/// <remarks/>
			public Picklist address1_addresstypecode;
        
			/// <remarks/>
			public string address1_city;
        
			/// <remarks/>
			public string address1_country;
        
			/// <remarks/>
			public string address1_county;
        
			/// <remarks/>
			public string address1_fax;
        
			/// <remarks/>
			public CrmFloat address1_latitude;
        
			/// <remarks/>
			public string address1_line1;
        
			/// <remarks/>
			public string address1_line2;
        
			/// <remarks/>
			public string address1_line3;
        
			/// <remarks/>
			public CrmFloat address1_longitude;
        
			/// <remarks/>
			public string address1_name;
        
			/// <remarks/>
			public string address1_postalcode;
        
			/// <remarks/>
			public string address1_postofficebox;
        
			/// <remarks/>
			public Picklist address1_shippingmethodcode;
        
			/// <remarks/>
			public string address1_stateorprovince;
        
			/// <remarks/>
			public string address1_telephone1;
        
			/// <remarks/>
			public string address1_telephone2;
        
			/// <remarks/>
			public string address1_telephone3;
        
			/// <remarks/>
			public string address1_upszone;
        
			/// <remarks/>
			public CrmNumber address1_utcoffset;
        
			/// <remarks/>
			public Key address2_addressid;
        
			/// <remarks/>
			public Picklist address2_addresstypecode;
        
			/// <remarks/>
			public string address2_city;
        
			/// <remarks/>
			public string address2_country;
        
			/// <remarks/>
			public string address2_county;
        
			/// <remarks/>
			public string address2_fax;
        
			/// <remarks/>
			public CrmFloat address2_latitude;
        
			/// <remarks/>
			public string address2_line1;
        
			/// <remarks/>
			public string address2_line2;
        
			/// <remarks/>
			public string address2_line3;
        
			/// <remarks/>
			public CrmFloat address2_longitude;
        
			/// <remarks/>
			public string address2_name;
        
			/// <remarks/>
			public string address2_postalcode;
        
			/// <remarks/>
			public string address2_postofficebox;
        
			/// <remarks/>
			public Picklist address2_shippingmethodcode;
        
			/// <remarks/>
			public string address2_stateorprovince;
        
			/// <remarks/>
			public string address2_telephone1;
        
			/// <remarks/>
			public string address2_telephone2;
        
			/// <remarks/>
			public string address2_telephone3;
        
			/// <remarks/>
			public string address2_upszone;
        
			/// <remarks/>
			public CrmNumber address2_utcoffset;
        
			/// <remarks/>
			public Key competitorid;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public string keyproduct;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public string name;
        
			/// <remarks/>
			public string opportunities;
        
			/// <remarks/>
			public Lookup organizationid;
        
			/// <remarks/>
			public string overview;
        
			/// <remarks/>
			public string referenceinfourl;
        
			/// <remarks/>
			public CrmMoney reportedrevenue;
        
			/// <remarks/>
			public CrmNumber reportingquarter;
        
			/// <remarks/>
			public CrmNumber reportingyear;
        
			/// <remarks/>
			public string stockexchange;
        
			/// <remarks/>
			public string strengths;
        
			/// <remarks/>
			public string threats;
        
			/// <remarks/>
			public string tickersymbol;
        
			/// <remarks/>
			public string weaknesses;
        
			/// <remarks/>
			public string websiteurl;
        
			/// <remarks/>
			public CrmFloat winpercentage;
		}
    
	
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class salesorder : BusinessEntity {
        
			/// <remarks/>
			public UniqueIdentifier billto_addressid;
        
			/// <remarks/>
			public string billto_city;
        
			/// <remarks/>
			public string billto_contactname;
        
			/// <remarks/>
			public string billto_country;
        
			/// <remarks/>
			public string billto_fax;
        
			/// <remarks/>
			public string billto_line1;
        
			/// <remarks/>
			public string billto_line2;
        
			/// <remarks/>
			public string billto_line3;
        
			/// <remarks/>
			public string billto_name;
        
			/// <remarks/>
			public string billto_postalcode;
        
			/// <remarks/>
			public string billto_stateorprovince;
        
			/// <remarks/>
			public string billto_telephone;
        
			/// <remarks/>
			public Lookup campaignid;
        
			/// <remarks/>
			public Lookup createdby;
        
			/// <remarks/>
			public CrmDateTime createdon;
        
			/// <remarks/>
			public Customer customerid;
        
			/// <remarks/>
			public CrmDateTime datefulfilled;
        
			/// <remarks/>
			public string description;
        
			/// <remarks/>
			public CrmMoney discountamount;
        
			/// <remarks/>
			public CrmDecimal discountpercentage;
        
			/// <remarks/>
			public CrmMoney freightamount;
        
			/// <remarks/>
			public Picklist freighttermscode;
        
			/// <remarks/>
			public CrmBoolean ispricelocked;
        
			/// <remarks/>
			public CrmDateTime lastbackofficesubmit;
        
			/// <remarks/>
			public Lookup modifiedby;
        
			/// <remarks/>
			public CrmDateTime modifiedon;
        
			/// <remarks/>
			public string name;
        
			/// <remarks/>
			public Lookup opportunityid;
        
			/// <remarks/>
			public string ordernumber;
        
			/// <remarks/>
			public Owner ownerid;
        
			/// <remarks/>
			public Lookup owningbusinessunit;
        
			/// <remarks/>
			public Picklist paymenttermscode;
        
			/// <remarks/>
			public Lookup pricelevelid;
        
			/// <remarks/>
			public Picklist pricingerrorcode;
        
			/// <remarks/>
			public Picklist prioritycode;
        
			/// <remarks/>
			public Lookup quoteid;
        
			/// <remarks/>
			public CrmDateTime requestdeliveryby;
        
			/// <remarks/>
			public Key salesorderid;
        
			/// <remarks/>
			public Picklist shippingmethodcode;
        
			/// <remarks/>
			public UniqueIdentifier shipto_addressid;
        
			/// <remarks/>
			public string shipto_city;
        
			/// <remarks/>
			public string shipto_contactname;
        
			/// <remarks/>
			public string shipto_country;
        
			/// <remarks/>
			public string shipto_fax;
        
			/// <remarks/>
			public Picklist shipto_freighttermscode;
        
			/// <remarks/>
			public string shipto_line1;
        
			/// <remarks/>
			public string shipto_line2;
        
			/// <remarks/>
			public string shipto_line3;
        
			/// <remarks/>
			public string shipto_name;
        
			/// <remarks/>
			public string shipto_postalcode;
        
			/// <remarks/>
			public string shipto_stateorprovince;
        
			/// <remarks/>
			public string shipto_telephone;
        
			/// <remarks/>
			public SalesOrderStateInfo statecode;
        
			/// <remarks/>
			public Status statuscode;
        
			/// <remarks/>
			public CrmDateTime submitdate;
        
			/// <remarks/>
			public CrmNumber submitstatus;
        
			/// <remarks/>
			public string submitstatusdescription;
        
			/// <remarks/>
			public CrmMoney totalamount;
        
			/// <remarks/>
			public CrmMoney totalamountlessfreight;
        
			/// <remarks/>
			public CrmMoney totaldiscountamount;
        
			/// <remarks/>
			public CrmMoney totallineitemamount;
        
			/// <remarks/>
			public CrmMoney totallineitemdiscountamount;
        
			/// <remarks/>
			public CrmMoney totaltax;
        
			/// <remarks/>
			public CrmBoolean willcall;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public class SalesOrderStateInfo {
        
			/// <remarks/>
			[System.Xml.Serialization.XmlAttributeAttribute()]
			public string formattedvalue;
        
			/// <remarks/>
			[System.Xml.Serialization.XmlTextAttribute()]
			public SalesOrderState Value;
		}
    
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public enum SalesOrderState {
        
			/// <remarks/>
			Active,
        
			/// <remarks/>
			Submitted,
        
			/// <remarks/>
			Canceled,
        
			/// <remarks/>
			Fulfilled,
        
			/// <remarks/>
			Invoiced,
		}
     
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/Query")]
			[System.Xml.Serialization.XmlIncludeAttribute(typeof(AllColumns))]
			public abstract class ColumnSetBase {
		}
		
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/Query")]
			public class AllColumns : ColumnSetBase {
		}
		           
		/// <remarks/>
		[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://schemas.microsoft.com/crm/2006/WebServices")]
			public abstract class Request {
		}
    
		
		</script>

	</HEAD>
	<body>
		<table class="layout" cellspacing="0" cellpadding="0" width="100%">
			
			<tr>
				<td class="leftBar" style="WIDTH:100%">
					<form runat="server" ID="Form1">
						<table width="100%">
							<tbody valign="top">
								<tr>
									<td align="center"><asp:Label id="lblResult" runat="server" EnableViewState="False" style="font-family:tahoma;"/></td>
								</tr>
							</tbody>
						</table>
					</form>
				</td>
			</tr>
			<tr height="23">
				<td class="statusBar">
					&nbsp;
				</td>
			</tr>
		</table>
	</body>
</HTML>
